/*
	File:		TargetVersMgt.h

	Contains:	xxx put contents here xxx

	Copyright:	 1993-1996 by Apple Computer, Inc., all rights reserved.

*/


 
#ifndef __TargetVersMgt__
#define __TargetVersMgt__

#ifndef __Files__
#include <Files.h>
#endif


typedef struct {
	FSSpec			fSrcFSSpec;
	long			fSrcDataType;
	Str31			fTgtFileName;
	long			fTgtVersionNum;
	ResType			fTgtFileType;		// Not supported in 4.0.0
	ResType			fTgtFileCreator;	// Not supported in 4.0.0
} TgtFileVersType;

typedef struct {
	FSSpec			fSrcFSSpec;
	long			fSrcDataType;
	OSType			fSrcRsrcType;	
	short			fSrcRsrcID;
	OSType			fTgtRsrcType;	
	short			fTgtRsrcID;
	long			fTgtRsrcVersionNum;
} TgtRsrcVersType;

typedef union {
	TgtFileVersType			fFileVers;
	TgtRsrcVersType			fRsrcVers;
} TargetVersPB, *TargetVersPBPtr;

#define	kVersTypeIsFile	-1
#define	kVersTypeIsRsrc	1

typedef long	(*TargetVersProcPtr)( TargetVersPBPtr );		
							
#endif
