//////////////////////////////////
//	Written by Deric Horn, 1996	//
//////////////////////////////////
//	Copyright 1996, Apple Computer, Inc., All Rights Reserved

Include		"DisplayTEXT.rsrc";			//	The Display TEXT startup function & related resources

Include		"SampleSplashScreen.rsrc";	//	Sample with a legal reference in it.

#define	kSetupCodeID	5000


//	If your installer script already has an 'inpr' resource, you may have to modify it to
//	modify it by adding the lines 'infn', "kLegalSetupCodeID," seen below to call the DisplayTEXT
//	code at startup.  You may want to consult the installer documentation for the details of
//	the 'inpr' resource.
resource 'inpr' (300) {
	format0 {
		useDiskTargetMode,				// Tells the Installer which interface to use, 
										// either disk based or folder based
		allowUserToSetSystemDisk,		// Restricts user from changing System Disk
		showSelectedSizeInCustom,
		setupFunctionSupplied,			// Tells Installer to call Setup Function
		allowCleanInstall,
		dontAllowServerAsTarget,
		'infn',							// Setup Function code resource type
		kSetupCodeID,					// Setup Function code resource ID
		{},
		""								// Default Target Folder name
	}
};


// The ID indicating the DisplayTEXT text should not be displayed
#define doNotDisplay	-1

//These region codes are defined in Script.h
#define		verUS		0
#define		verFrance		1
#define		verBritain		2
#define		verGermany		3
#define		verItaly		4
#define		verNetherlands	5
#define		verFrBelgiumLux	6
#define		verSweden		7
#define		verSpain		8
#define		verDenmark		9
#define		verPortugal		10
#define		verFrCanada		11
#define		verNorway		12

#define		verJapan		14
#define		verFinland		17
#define		verFrSwiss		18
#define		verGrSwiss		19
#define		verTurkey		24

//	Should be in Script.h but aren't yet, as of ETO 21
#define		verCatalan		73
#define		verFrUniversal	91


//	Resource type definition used in the DisplayTEXT Startup function.
type 'LPic'
{
		integer;								//	Default language ID
		integer = $$Countof(LanguageArray);
		array LanguageArray
		{
				integer;						//	System language ID found in Script.h
				integer;						//	unique local Res ID, offset from 5000
				integer 	oneByte, twoByte;	//	Is this language a 1 or 2 byte language
		};
};


resource 'LPic' ( 5000 )
{
	2,					//	Default Language ID
	{					//	language, local resource ID offset from 5000 same as MENU ID, one or two byte language
		verGermany,			1,				oneByte,
		verUS,				2,				oneByte,
		verSpain,			3,				oneByte,
		verFrance,			4,				oneByte,
		verItaly,			5,				oneByte,
		verJapan,			6,				twoByte,
		verNetherlands,		7,				oneByte,
		verSweden,			8,				oneByte,
		verDenmark,			9,				oneByte,
		verNorway,			10,				oneByte,
		verFrCanada,		4,				oneByte,
		verTurkey,			doNotDisplay,	oneByte,
		verFrUniversal,		4,				oneByte,			// not defined in Script.h yet
		verFinland,			doNotDisplay,	oneByte,
		verFrSwiss,			4,				oneByte,
		verGrSwiss,			1,				oneByte,
		verBritain,			11,				oneByte,
		verCatalan,			12,				oneByte				// not defined in Script.h yet
	}
};

//			Multilingual Support Details 		//
//	If you would like to coerce one script language to another, for instance SwissFrench to French in the below
//	example, just add another line : "langSwisFrench, 4, oneByte,".  This will cause a SwissFrench OS to display
//	the text in language "4", French.
//	If the dialog is not to be diplayed at all for a particular language, say langArabic, add a line:
//	"langArabic, doNotDisplay, oneByte,".  The "doNotDisplay" flag will coerce the script to go directly to
//	the software installation screen.
//resource 'LPic' ( 5000 )
//{
//	2,					//	Default Language ID
//	{					//	language, local resource ID offset from 5000 same as MENU ID, one or two byte language
//		langFrench,			4,				oneByte,
//		langSwissFrench,	4,				oneByte,
//		langArabic,			doNotDisplay,	oneByte,
//	}
//};
