/*
	File:		GenericReadMe.h

*/

#ifndef __GENERICREADME_PLUGIN__
#define __GENERICREADME_PLUGIN__

#ifndef REZ		// Don't want Rez to see the rest of the file

#ifdef __cplusplus
extern "C" {
#endif

#include <Types.h>
#include <Events.h>
#include <TextEdit.h>

#include "UpgraderPlugin.h"


enum
	{
	kImportantInfoPanelRsrcID = 5000
	};


// ImportantInfo panel items	
enum	
	{
	kContinueButton = 1,
	kGoBackButton,
	kPrintButton,
	kSaveButton,
	kDocItem,
	kTitleTextItem,
	kHelpButton = 10
	};
	
// Preference resource definitions, bit-masks and types.

#define kImportantInfoPrefsResType	'rmpr'	// plugin preference resource type.

enum										// Bit masks for the 'flags' field of the WelcomePrefs struct
	{
	kMainTextInFile 	= 0x8000,
	kHelpTextInFile		= 0x4000
	};

typedef struct								// plugin preference resource struture
	{
	UInt16	format;
	UInt16	flags;
	short	mainTextReferenceID;			// Changed all resource ID types from UInt16 to short
	short	mainPICTBaseResID;
	short	helpTextReferenceID;
	short	helpPICTBaseResID;
	short	STRListRsrsID;
	
	} ImportantInfoPrefs, *ImportantInfoPrefsPtr, **ImportantInfoPrefsHandle;



struct HelpPrefs 
	{
	DocLocationType	location;				// Change from Boolean to DocLocationType
	short			resID;
	short			basePICTResID;
	Str255			panelTitleStr;
	};
typedef struct HelpPrefs HelpPrefs, *HelpPrefsPtr, **HelpPrefsHandle;


	
// P R O T O T Y P E S


#endif // REZ
#ifdef __cplusplus
}
#endif	// __cplusplus
#endif	// __IMPORTANTINFO_PLUGIN__