/*
	File:		SimpleAppLauncher.h
*/

#ifndef __SAL_PLUGIN__
#define __SAL_PLUGIN__

#define	kDriveSetupAliasRsrcID		3500		// Use #define so that Rez can use them as well
#define	kDiskFirstAidpAliasRsrcID	3600
#define	kHDSetupAliasRsrcID			3700

#define	kValidDriveSetupMachinesResID	3500	// List of valid/invalid machine gestalt ID's for 
												// DriveSetup application.
#define	kValidMachinesResType	'valm'
#define kInvalidMachinesResType	'invm'
#define kSALPrefsResType		'slpr'			// SAL plugin preference resource type.
#define kResIDResType			'paul'
#ifndef REZ										// Don't want Rez to see the rest of the file

#ifdef __cplusplus
extern "C" {
#endif

#include <Types.h>
#include <Events.h>
#include <TextEdit.h>

#include "UpgraderPlugin.h"


enum								// Panel DITL resource ID's
	{
	kSALPanelRsrcID 	= 3500
	};



enum								// SAL panel items	
	{
	kContinueButton = 1,
	kGoBackButton,
	kBackgroundPICTitem,
	kHelpButton = 6,
	kInstallStepsTextItem,
	kTitleTextItem,
	kLaunchCheckBox = 9
	};


enum								// Help panel items
	{
	kHelpCloseButton = 1,
	kHelpPrintButton,
	kHelpSaveButton
	};


enum								// Return codes
	{
	kContinueInstallerSetup,
	kQuitInstallerNow
	};

enum								// Bit masks for the 'flags' field of the SALPrefs struct
	{
	kMainTextInFile 		= 0x8000,
	kHelpTextInFile			= 0x4000,
	kKeepApplicationOpen	= 0x2000,
	kShowLaunchCheckbox		= 0x1000,
	kPrecheckLaunchCheckbox	= 0x0800
	};
	
// Typedefs

	
typedef struct						// SAL plugin preference resource struture
	{
	UInt16	format;
	UInt16	flags;
	SInt16	mainTextReferenceID;
	SInt16	helpTextReferenceID;
	SInt16	basePICTResID;
	SInt16	backgroundPICTResID;
	SInt16	SALSTRListRsrsID;
	SInt16	applicationflrfID;
	SInt16	documentflrfID;
	
	} SALPrefs, *SALPrefsPtr, **SALPrefsHandle;
	
// P R O T O T Y P E S

void 	DisplayHelp(void);
Boolean	HandleEventForHelpPanel(EventRecord *inEvent);
short	GetLineHeight(TEHandle theTE, short lineNum);
void	HandleScroller( PanelPtr thePanel, Point pt, short textItem, short scrollerItem);

#endif // REZ
#ifdef __cplusplus
}
#endif	// __cplusplus
#endif	// __SAL_PLUGIN__