
#ifndef __InstallationPluginExt__
#define __InstallationPluginExt__


#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

/********************************************************************************************************/
/*																										*/
/*								Software Installer Preflight Routine									*/
/*																										*/
/*																										*/
/*	Prototype:																							*/
/* SoftwareInstallerPreflightResult SoftwareInstallerPreflightRoutine(SoftwareInstallerPreflightPBPtr);	*/
/*																										*/
/********************************************************************************************************/

// Result definition
enum {
	kNoError					= 0,
	kInternalError				= -1
};

typedef SInt32 SoftwareInstallerPreflightResult;


// Parameter block definition
struct SoftwareInstallerPreflightPBRec {
	
	// Fields set on entry	
	SInt16							fDestinationVRefNum;				// Volume RefNum of selected destination disk.
	SInt32							fRefCon;							// 32-bit value passed to code resource from client data file.
	Boolean							fDoingCleanInstall;					// Flag set if user has specified a clean install.  Ignore fDestinationVRefNum field if true.
	
	// Fields set by you on exit	
	Boolean							fSkipOnEasy;						// Flag to force software installer to be skipped when running in Easy HI mode
	Boolean							fSkipOnCustom;						// Flag to force software installer to be skipped when running in Custom HI mode
	Boolean							fOverrideDefaultSelection;			// Flag to force initial selection state of software installer checkbox to that specified in the fSelectIfOverridden field.
	Boolean							fSelectIfOverridden;				// Selection state of software installer checkbox if fOverrideDefaultSelection field is true.
	
};
typedef struct SoftwareInstallerPreflightPBRec SoftwareInstallerPreflightPBRec, *SoftwareInstallerPreflightPBPtr;


#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __InstallationPluginExt__ */
