/*
 	File:		Sample.r
 
 	Contains:	Location Manager SDK Sample Rez data...
 
 	Version:	ALM SDK 2.0
 				Package:	Location Manager SDK 2.0
 
 	Copyright:	 1996-1997 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		Please include the the file and version information (from above) with
 				the problem description.  Developers belonging to one of the Apple
 				developer programs can submit bug reports to:
 
 					devsupport@apple.com
 
*/

#define		thng_RezTemplateVersion		1
#define		DLOG_RezTemplateVersion		1

// ------------------------------------------------------------------------------------------------- 

// Module Include...

#include	"Sample.h"

// MacOS Includes...

#include	"Components.r"
#include	"LocationManager.r"

// ------------------------------------------------------------------------------------------------- 

// Bring in the binary resource stuff...

include		"Sample.rsrc";

// ------------------------------------------------------------------------------------------------- 

// Information for the component manager -- ##### be sure to change the subtype!

resource 'thng' (128, "Generic Module") {
	kALMComponentType,
	'MSWD',		// Component Subtype--must be unique (use your registered creator)!
	'????',		// Component Manufacturer--something descriptive (we use 'appl')
	0x0,		// Flags (32 bits); could be kALMMultiplePerLocation and/or kALMDescriptionGetsStale
	kAnyComponentFlagsMask,
	kExecutableRsrcType, kExecutableRsrcID,
	kNameRsrcType, kNameRsrcID,
	kDescRsrcType, kDescRsrcID,
	kIconRsrcType, kIconRsrcID,
	0x0,	// Version
	componentDoAutoVersion,
	kIconRsrcID,
	{}		// No platform info
};

resource kNameRsrcType (kNameRsrcID, "Module Name") {
	"Generic Module"
};

resource kDescRsrcType (kDescRsrcID, "Module Description") {
	"This is the Generic Sample module for Location Manager SDK."
};

// Internationalization in an easy place for internationalizers to get at it...

resource kALMAltScriptManagerInfoRsrcType (kALMAltScriptManagerInfoRsrcID, "Script Info") {
	kALMScriptInfoVersion,
	smRoman,		// Script
	verUS,			// Version
	langEnglish,	// Language
	10,				// Size
	"Geneva"		// Font
};

// So that the Generic module can be customized, a list of applications, and
// pairs of preference file resources...

resource kAppsRsrcType (kAppsQuitRsrcID, "Apps to Quit") {{
	"MSWD", quitOnGetOrSet
}};

resource kAppsRsrcType (kAppsEditRsrcID, "Apps to Launch") {{
	"MSWD", launchFromEdit
}};

resource kFilesRsrcType (kFilesRsrcStartID, "Word Settings (5)") {
	"Word Settings (5)"
};

resource kRestartRsrcType (kRestartRsrcStartID, "Word Settings (5)") {
	kNoRestart
};

// ------------------------------------------------------------------------------------------------- 

// Error messages; keep positions in sync with the error numbers...

resource 'STR#' (kSampleErrStrRsrcID, "Errors") {{
	"Could not import because preferences on this machine match dates on imported set, "
		"so there would be no way to tell them apart.",
	"Could not quit an application using modules preferences.",
	
	""
}};

resource 'STR#' (kSampleMiscStrRsrcID, "Misc Messages") {{
	"Preference files containing ^0 modified at ^1 on ^2.",
	
	""
}};

// ------------------------------------------------------------------------------------------------- 

// Handy template resources so that we can use ResEdit/Resourcerer...

resource 'TMPL' (10000, "trip", purgeable) {{

	"Header Version", 			"DWRD",
	"Script Code", 				"DWRD",
	"Region Code", 				"DWRD",
	"Language Code", 			"DWRD",
	"Default Font Size", 		"DWRD",
	"Default Font Name", 		"PSTR"

}};

resource 'TMPL' (10001, "thng", purgeable) {{

	"Component Type", 			"TNAM",
	"Component Subtype", 		"TNAM",
	"Component Manufacturer",	"TNAM",
	"Register Component",		"BBIT",
	"Fast Dispatch Calls",		"BBIT",
	"Reserved", 				"BBIT",
	"Reserved", 				"BBIT",
	"Reserved", 				"BBIT",
	"Reserved", 				"BBIT",
	"Reserved", 				"BBIT",
	"Reserved", 				"BBIT",
	"Type Flags",				"HBYT",
	"Subtype Flags",			"HBYT",
	"Manufacturer Flags",		"HBYT",
	"Flag Mask", 				"HLNG",
	"Code Resource Type", 		"TNAM",
	"Code Resource ID", 		"DWRD",
	"Name Resource Type", 		"TNAM",
	"Name Resource ID", 		"DWRD",
	"Info Resource Type", 		"TNAM",
	"Info Resource ID", 		"DWRD",
	"Icon Resource Type",		"TNAM",
	"Icon Resource ID", 		"DWRD",
	"Component Version", 		"HLNG",
	"Registration Flags",		"HLNG",
	"Icon Family",				"DWRD",
	"Reserved",					"DWRD",
	"Platform Count",			"OCNT",
	"*****",					"LSTC",
	"Component Flags",			"HLNG",
	"Code Type",				"HLNG",
	"Code ID",					"DWRD",
	"Platform ID",				"DWRD",
	"*****",					"LSTE"

}};

resource 'TMPL' (10002, kAppsRsrcTypeString, purgeable) {{

	"Application Signatures",	"OCNT",
	"*****",					"LSTC",
	"App Sig",					"TNAM",
	"OnSet",					"BBIT",
	"OnGet",					"BBIT",
	"OnEdit",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Align",					"AWRD",
	"*****",					"LSTE"

}};

resource 'TMPL' (10003, kFilesRsrcTypeString, purgeable) {{

	"File Name",				"PSTR",

}};

resource 'TMPL' (10004, kRestartRsrcTypeString, purgeable) {{

	"Restart",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Reserved",					"BBIT",
	"Align",					"AWRD",

}};

