/*
	File:			Extension.r

	Contains:		Resource source and resource editing instructions.

	Version:		1

	Written by:		Ben Koning

	Copyright:		 1997 by Apple Computer, Inc., all rights reserved.

	File Ownership:

		DRI:				None

		Other Contact:		Ben Koning

		Technology:			MacOS System 7

	Writers:

		(BAK)	Ben Koning

	Change History (most recent first):

		 <4>	 7/15/97	BAK		Icon family: Move bridge right 1 pixel.
		 <3>	 7/15/97	BAK		Slight changes to icon family: Small icons' card edge longer;
									bridge longer.
		 <2>	  7/9/97	BAK		Set sysz to $1200.  Created icon family.
		 <1> 	  7/1/97	BAK		First checkin.
*/



/*
 * Add in the resource containing executable code that we just compiled:
 */

include "INIT=0.rsrc";



/*
 * Provide information on how much space in the System [Memory] Heap we use.
 * Based on size of the driver we are adding, plus some slop.  This value
 * need not be perfectly exact and is only a hint to the system:
 */

data 'sysz' (0) {
	$"0000 1200"
};



/*
 * Tell the system what version of this piece of software this is:
 */

data 'vers' (1) {
	$"0100 2000 0000 0531 2E30 6430 4250 6F77"            /* .. ....1.0d0BPow */
	$"6572 4D61 6320 3434 3030 204F 7065 6E20"            /* erMac 4400 Open  */
	$"4669 726D 7761 7265 2046 6978 2031 2E30"            /* Firmware Fix 1.0 */
	$"6430 2C20 A920 3139 3937 2041 7070 6C65"            /* d0,  1997 Apple */
	$"2043 6F6D 7075 7465 722C 2049 6E63 2E"              /*  Computer, Inc. */
};



/*
 * Icon family:
 */

data 'ICN#' (-16455) {
	$"003F FE00 0040 0100 0020 0200 7FF0 0FFE"            /* .?..@... .... */
	$"8000 0001 8000 0001 8000 0001 8000 0001"            /* ............ */
	$"8FFF FFE3 8800 0025 8873 9029 8894 1031"            /* ..%s).1 */
	$"88E4 2021 8908 4041 890E 4081 8800 0141"            /*  !.@A.@..A */
	$"8881 0221 89C3 8411 8ABD 4ECB 8FFF F7C5"            /* .!Ä.Nˏ */
	$"8881 2389 8800 47D1 8FFF A6E1 8209 1041"            /* #.Gя.A */
	$"83FA 0881 8004 0501 8008 0201 8010 0401"            /* .......... */
	$"807F FE01 8080 0101 8040 0201 7FE0 07FE"            /* ....@.... */
	$"003F FE00 007F FF00 003F FE00 7FFF FFFE"            /* .?.....?.. */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /*  */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /*  */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /*  */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /*  */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /*  */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /*  */
	$"FFFF FFFF FF80 01FF FFC0 03FF 7FE0 07FE"            /* .... */
};

data 'ics#' (-16455) {
	$"07E0 FC3F 8001 8001 BFF9 A00B AFCD ACC9"            /* .?...ͬ */
	$"A851 A033 B3FD 9EB9 8111 8221 87E1 FC3F"            /* Q3.!? */
	$"07E0 FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* . */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FC3F"            /* ? */
};

data 'ics8' (-16455) {
	$"0000 0000 00FF FFFF FFFF FF00 0000 0000"            /* .......... */
	$"FFFF FFFF FFFF F7F7 F7F7 FFFF FFFF FFFF"            /*  */
	$"FFF7 F7F7 F7F7 F6F6 F6F6 F7F7 F7F7 F7FF"            /*  */
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"            /*  */
	$"FFF6 FFFF FFFF FFFF FFFF FFFF FFF6 F6FF"            /*  */
	$"FFF6 FF92 9292 9292 9292 9292 FFF6 33FF"            /* 3 */
	$"FFF6 FF92 7F7F 7F7F 7F7F 7F92 FF33 33FF"            /* .......33 */
	$"FFF6 FF92 7F7F 7F2A 7F7F 7F92 3333 33FF"            /* ...*...333 */
	$"FFF6 FF92 7F7F 9292 927F 7F08 3333 33FF"            /* .....333 */
	$"FFF6 FF92 9292 9292 9292 08D8 0833 33FF"            /* ..33 */
	$"FFF6 FFFF 0505 FFFF FF08 D8D8 D808 F6FF"            /* .... */
	$"FFF6 F6FF FFFF FFF6 3333 08D8 08F6 F6FF"            /* 33.. */
	$"FFF6 F6F6 F6F6 F633 3333 3308 F6F6 F6FF"            /* 3333. */
	$"FFF6 F6F6 F6F6 3333 3333 33F6 F6F6 F6FF"            /* 33333 */
	$"FFF6 F6F6 F6FF FFFF FFFF FFF6 F6F6 F6FF"            /*  */
	$"FFFF FFFF FFFF 0000 0000 FFFF FFFF FFFF"            /* .... */
};

data 'ics4' (-16455) {
	$"0000 0FFF FFF0 0000 FFFF FFCC CCFF FFFF"            /* ..... */
	$"FCCC CC0C 0C0C CCCF F0C0 C0C0 C0C0 C0CF"            /* ... */
	$"FCFF FFFF FFFF F00F F0F8 8888 8888 F02F"            /* ./ */
	$"FCF8 6666 6668 F22F F0F8 6667 6668 222F"            /* fffh/fgfh"/ */
	$"FCF8 6688 8661 222F F0F8 8888 8813 122F"            /* fa"/../ */
	$"FCFF 11FF F133 310F F0CF FFF0 2213 10CF"            /* .31.".. */
	$"FC0C 0C02 2221 0C0F F0C0 C022 2220 C0CF"            /* ..."!..""  */
	$"FC0C 0FFF FFFC 0C0F FFFF FF00 00FF FFFF"            /* ...... */
};

data 'icl8' (-16455) {
	$"0000 0000 0000 0000 0000 FFFF FFFF FFFF"            /* .......... */
	$"FFFF FFFF FFFF FF00 0000 0000 0000 0000"            /* ......... */
	$"0000 0000 0000 0000 00FF 00F7 F7F7 F7F7"            /* .......... */
	$"F7F7 F7F7 F7F7 F7FF 0000 0000 0000 0000"            /* ........ */
	$"0000 0000 0000 0000 0000 FF00 F6F6 F6F6"            /* ........... */
	$"F6F6 F6F6 F6F7 FF00 0000 0000 0000 0000"            /* ......... */
	$"00FF FFFF FFFF FFFF FFFF FFFF F6F6 F6F6"            /* . */
	$"F6F6 F6F6 FFFF FFFF FFFF FFFF FFFF FF00"            /* . */
	$"FFF6 F7F7 F7F7 F7F7 F7F7 F7F7 F6F6 F6F6"            /*  */
	$"F6F6 F6F6 F6F7 F7F7 F7F7 F7F7 F7F7 F7FF"            /*  */
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"            /*  */
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F7FF"            /*  */
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"            /*  */
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F7FF"            /*  */
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"            /*  */
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F7FF"            /*  */
	$"FFF6 F6F6 A5A5 A5A5 A5A5 A5A5 A5A5 A5A5"            /*  */
	$"A5A5 A5A5 A5A5 A5A5 A5A5 A5F6 F6F6 16FF"            /* . */
	$"FFF6 F6F6 A592 9292 9292 9292 9292 9292"            /*  */
	$"9292 9292 9292 9292 9292 A5F6 F616 33FF"            /* .3 */
	$"FFF6 F6F6 A592 9292 92FF FFFF 9292 FFFF"            /*  */
	$"FF92 92FF 9292 9292 9292 A5F6 1633 33FF"            /* .33 */
	$"FFF6 F6F6 A592 9292 FF92 92FF 92FF 9292"            /*  */
	$"9292 92FF 9292 9292 9292 A516 3333 33FF"            /* .333 */
	$"FFF6 F6F6 A592 9292 FFFF FF92 92FF 9292"            /*  */
	$"9292 FF92 9292 9292 9292 1633 3333 33FF"            /* .3333 */
	$"FFF6 F6F6 A592 92FF 9292 9292 FF92 9292"            /*  */
	$"92FF 9292 9292 9292 9216 3333 3333 33FF"            /* .33333 */
	$"FFF6 F6F6 A592 92FF 9292 9292 FFFF FF92"            /*  */
	$"92FF 9292 9292 9292 1633 3333 3333 33FF"            /* .333333 */
	$"FFF6 F6F6 A592 9292 9292 9292 9292 9292"            /*  */
	$"9292 9292 9292 9216 0833 3333 3333 33FF"            /* ..333333 */
	$"FFF6 F6F6 A592 9292 D892 9292 9292 92D8"            /* ؒ */
	$"9292 9292 9292 1608 0808 3333 3333 33FF"            /* ....33333 */
	$"FFF6 F6F6 A592 92D8 D8D8 9292 9292 D8D8"            /* ؒ */
	$"D892 9292 9216 0808 0808 0833 3333 33FF"            /* ؒ......3333 */
	$"FFF6 F6F6 A592 D892 D892 D816 16D8 92D8"            /* ؒؒ..ؒ */
	$"92D8 9292 16D8 D808 D8D8 0808 3333 16FF"            /* ؒ....33. */
	$"FFF6 F6F6 A5D8 D8D8 D8D8 D8D8 D8D8 D8D8"            /*  */
	$"D8D8 D816 08D8 D8D8 D8D8 0808 0816 F7FF"            /* ...... */
	$"FFF6 F6F6 A592 9292 D892 9292 9292 92D8"            /* ؒ */
	$"9292 1608 0808 D8D8 D808 0808 16F6 F7FF"            /* ........ */
	$"FFF6 F6F6 A592 9292 9292 9292 9292 9292"            /*  */
	$"9216 0808 08D8 D8D8 D8D8 0816 F6F6 F7FF"            /* ...... */
	$"FFF6 F6F6 A5A5 A5A5 A5A5 A5A5 A5A5 A5A5"            /*  */
	$"1633 3308 08D8 D808 D8D8 16F6 F6F6 F7FF"            /* .33.... */
	$"FFF6 F6F6 F6F6 A505 0505 0505 A5F6 F616"            /* ...... */
	$"3333 3333 0808 0808 0816 F6F6 F6F6 F7FF"            /* 3333...... */
	$"FFF6 F6F6 F6F6 A5A5 A5A5 A5A5 A5F6 1633"            /* .3 */
	$"3333 3333 3308 0808 16F6 F6F6 F6F6 F7FF"            /* 33333.... */
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F616 3333"            /* .33 */
	$"3333 3333 3333 0816 F6F6 F6F6 F6F6 F7FF"            /* 333333.. */
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 1633 3333"            /* .333 */
	$"3333 3333 3333 16F6 F6F6 F6F6 F6F6 F7FF"            /* 333333. */
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F616 3333 3333"            /* .3333 */
	$"3333 3333 3316 F6F6 F6F6 F6F6 F6F6 F7FF"            /* 33333. */
	$"FFF6 F6F6 F6F6 F6F6 F6FF FFFF FFFF FFFF"            /*  */
	$"FFFF FFFF FFFF FFF6 F6F6 F6F6 F6F6 F7FF"            /*  */
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"            /* ....... */
	$"0000 0000 0000 00FF F6F6 F6F6 F6F6 F7FF"            /* ....... */
	$"FFF6 F6F6 F6F6 F6F6 F6FF 0000 0000 0000"            /* ...... */
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F7FF"            /* ...... */
	$"00FF FFFF FFFF FFFF FFFF FF00 0000 0000"            /* ...... */
	$"0000 0000 00FF FFFF FFFF FFFF FFFF FF00"            /* ...... */
};

data 'icl4' (-16455) {
	$"0000 0000 00FF FFFF FFFF FFF0 0000 0000"            /* ......... */
	$"0000 0000 0F0C CCCC CCCC CCCF 0000 0000"            /* .......... */
	$"0000 0000 00F0 CCCC CCCC CCF0 0000 0000"            /* ......... */
	$"0FFF FFFF FFFF CCCC CCCC FFFF FFFF FFF0"            /* . */
	$"FCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCF"            /*  */
	$"FCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCF"            /*  */
	$"FCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCF"            /*  */
	$"FCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCF"            /*  */
	$"FCCC EEEE EEEE EEEE EEEE EEEE EEEC CCBF"            /* ̿ */
	$"FCCC E878 7878 7878 7878 7878 78EC CB2F"            /* xxxxxxxxxx/ */
	$"FCCC E787 8FFF 87FF F78F 8787 87EC B22F"            /* 燏/ */
	$"FCCC E878 F87F 7F78 787F 7878 78EB 222F"            /* x..xx.xxx"/ */
	$"FCCC E787 FFF7 8F87 87F7 8787 87B2 222F"            /* "/ */
	$"FCCC E87F 7878 F878 7F78 7878 7B22 222F"            /* .xxx.xxx{""/ */
	$"FCCC E78F 8787 FFF7 8F87 8787 B222 222F"            /* 珇""/ */
	$"FCCC E878 7878 7878 7878 787B 1222 222F"            /* xxxxxxxx{.""/ */
	$"FCCC E787 3787 8783 8787 87B1 1122 222F"            /* 7.""/ */
	$"FCCC E873 3378 7833 3878 7B11 1112 222F"            /* s3xx38x{..."/ */
	$"FCCC E838 3832 2383 8387 B331 3311 22BF"            /* 882#13." */
	$"FCCC E333 3333 3333 333B 1333 3311 1BCF"            /* 333333;.33.. */
	$"FCCC E787 3787 8783 87B1 1133 3111 BCCF"            /* 7.31. */
	$"FCCC E878 7878 7878 7B11 1333 331B CCCF"            /* xxxxx{..33. */
	$"FCCC EEEE EEEE EEEE B221 1331 33BC CCCF"            /* !.13 */
	$"FCCC CCE1 1111 ECCB 2222 1111 1BCC CCCF"            /* ..""... */
	$"FCCC CCEE EEEE ECB2 2222 2111 BCCC CCCF"            /* ""!. */
	$"FCCC CCCC CCCC CB22 2222 221B CCCC CCCF"            /* """". */
	$"FCCC CCCC CCCC B222 2222 22BC CCCC CCCF"            /* ̲"""" */
	$"FCCC CCCC CCCB 2222 2222 2BCC CCCC CCCF"            /* """"+ */
	$"FCCC CCCC CFFF FFFF FFFF FFFC CCCC CCCF"            /*  */
	$"FCCC CCCC F000 0000 0000 000F CCCC CCCF"            /* ....... */
	$"FCCC CCCC CF00 0000 0000 00FC CCCC CCCF"            /* ...... */
	$"0FFF FFFF FFF0 0000 0000 0FFF FFFF FFF0"            /* ...... */
};

