/*
	File:		SAMLauncher.h

	Contains:	Definitions for the SAM Installer Plugin.
	

	Written by:	Canice Bowe

	Copyright:	 1996-97 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

	To Do:
*/
#ifndef __SAM_PLUGIN__
#define __SAM_PLUGIN__

#define kSAMPrefsResType	'sapr'			// <04> SAM plugin preference resource type.
#define	kSAMBaseResIDIndex	12000
#ifndef REZ										// <01> Don't want Rez to see the rest of the file

#ifdef __cplusplus								// <01>
extern "C" {
#endif

#include <Types.h>
#include <Events.h>
#include <TextEdit.h>

#include "UpgraderPlugin.h"

enum	
	{
	kSAMflrfID			= kSAMBaseResIDIndex
	};
	
enum 
	{
	kVirusPanelButtonState = 'vibs'
	};
	
enum								// Panel DITL resource ID's
	{
	kSAMPanelRsrcID 	= kSAMBaseResIDIndex
	};

enum								// SAM panel items	
	{
	kContinueButton = 1,
	kGoBackButton,
	kHelpButton,
	kScanForVirusesButton,
	kRepairButton,
	kDoNothingButton,
	kTitleTextItem = 7,
	kSAMPanelTextItem = 8
	};

enum								// Bit masks for the 'flags' field of the SAMPrefs struct
	{
	kHelpTextInFile		= 0x8000
	};
	
enum {
	kMaxAttachedVolumes = 100							// <09>												// max number of volumes which can be 'attached' to the mac
};

typedef enum 
	{	
	kScanForViruses,
	kRepair,
	kDoNothing
	}RadioButtonStates;	
	
// Typedefs
	
typedef struct						// SAM plugin preference resource struture
	{
	UInt16	format;
	UInt16	flags;
	UInt16	mainTextReferenceID;
	UInt16	helpTextReferenceID;
	UInt16	baseHelpPICTResID;
	UInt16	SAMSTRListRsrsID;
	UInt16	SAMAppFileRefRsrsID;
	} SAMPrefs, *SAMPrefsPtr, **SAMPrefsHandle;

struct VolumeList {										// <09>
	Str255		volName;
	short		volRefNum;
	short		sswInstalled;
};
typedef struct VolumeList VolumeList;

/*******************************************************************
File Mgt. stuff
*******************************************************************/
#define BTst( a, b )				( ( ( unsigned long ) ( a ) & ( 1UL << ( b ) ) ) != 0 )
const SInt16	badVol						= -32768;				// A bad vRefNum
const SInt16	kMaxSCSIDRefNum 			= 0xFFDF;             	// Driver refNum for the SCSI device #0 (-33) 
const SInt16	kMinSCSIDRefNum 			= 0xFFD8;				// Driver refNum for the SCSI device #7 (-40) 
const SInt16	kFloppyDriveRefNum			= 0xFFFB;				// Driver refNum for the floppy drive (-5)
const SInt16	offlineRefNum				= 0;					// The cancel button
const SInt16	floppy1DrvNum				= 1;
const SInt16	floppy2DrvNum				= 2;
const SInt16	floppy3DrvNum				= 3;
const SInt16	kHFSFileManagerID			= 0;
const SInt16	AppleShareFileManagerID		= 1;					// File System ID for AppleShare
const SInt16	TOPSFileManagerID			= 0x11;					// File System ID for TOPS
const SInt16	SONYRefNum 					= -5;					// .Sony Driver 
const SInt16	oldHDRefNum					= -2;					// Old HD 20 Driver
const SInt16	kHighSierraFileManagerID 	= 0x4242;
const SInt16	kISO9660FileManagerID 		= 0x4147;
const SInt16	kAudioCDFileManagerID 		= 0x4A48;
const SInt16	kNoStartupDevice			= 0x6666;				// PRAM value when there is no valid startup device (extracted from "Startup Disk" cdev)

enum LockTypes {
	kUnlocked,
	kHWLock,
	kSWLock,
	kNoAccess
};
typedef enum LockTypes LockTypes;

enum VolWhereTypes {
	kHD,
	kFloppy1,
	kFloppy2,
	kFloppy3,
	kAppleShare,
	kRAMDisk,
	kTOPS,
	kAUXVolume,
	kCDROM,
	kUnknown
};
typedef enum VolWhereTypes VolWhereTypes;

enum VolStatusTypes {
	OnLine,
	OffLine,
	Unmounted
};
typedef enum VolStatusTypes VolStatusTypes;


#endif // REZ
#ifdef __cplusplus
}
#endif	// __cplusplus
#endif	// __SAM_PLUGIN__